﻿using System;
using System.Collections.Generic;

namespace YieldReturn
{
    class Program
    {
        static void Main()
        {
            IEnumerable<string> stringEnumerable = GetConsoleColors(2);

            foreach (string color in stringEnumerable)
            {
                Console.WriteLine(color);
            }

            Console.WriteLine();

            using (IEnumerator<string> colors = stringEnumerable.GetEnumerator())
            {
                while(colors.MoveNext())
                {
                    string color = colors.Current;

                    Console.WriteLine(color);
                }
            }

            Console.WriteLine();

            stringEnumerable = GetConsoleColors(4);

            foreach (string color in stringEnumerable)
            {
                Console.WriteLine(color);
            }
            foreach (string color in stringEnumerable)
            {
                Console.WriteLine(color);
            }

            Console.WriteLine();

            Console.ReadLine();
        }

        static IEnumerable<string> GetConsoleColors(int maxItems)
        {
            int currentItem = 0;

            if(currentItem >= maxItems)
            {
                yield break;
            }

            yield return ("Color:" + ConsoleColor.Red.ToString());

            currentItem++;

            if (currentItem >= maxItems)
            {
                yield break;
            }

            yield return ("Color:" + ConsoleColor.Green.ToString());

            currentItem++;

            if (currentItem >= maxItems)
            {
                yield break;
            }

            yield return ("Color:" + ConsoleColor.Blue.ToString());
        }
    }
}